'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _instantsearch = require('instantsearch.js');

var _instantsearch2 = _interopRequireDefault(_instantsearch);

var _addCSS = require('./addCSS');

var _addCSS2 = _interopRequireDefault(_addCSS);

var _clickAnalytics = require('./clickAnalytics');

var _removeCSS = require('./removeCSS');

var _removeCSS2 = _interopRequireDefault(_removeCSS);

var _stopwords = require('./stopwords');

var _stopwords2 = _interopRequireDefault(_stopwords);

require('./closestPolyfill');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var InstantSearch = function () {
  function InstantSearch(_ref) {
    var _this = this;

    var analytics = _ref.analytics,
        applicationId = _ref.applicationId,
        apiKey = _ref.apiKey,
        autocompleteSelector = _ref.autocomplete.inputSelector,
        clickAnalytics = _ref.clickAnalytics,
        indexName = _ref.indexName,
        indexPrefix = _ref.indexPrefix,
        _ref$instantsearch = _ref.instantsearch,
        enabled = _ref$instantsearch.enabled,
        hideAutocomplete = _ref$instantsearch.hideAutocomplete,
        paginationSelector = _ref$instantsearch.paginationSelector,
        selector = _ref$instantsearch.selector,
        subdomain = _ref.subdomain;

    _classCallCheck(this, InstantSearch);

    if (!enabled) return;

    this.locale = null;
    this.indexName = indexName || '' + indexPrefix + subdomain + '_articles';
    this.trackClick = (0, _clickAnalytics.createClickTracker)(this, this.indexName);

    this._temporaryHiding({
      hideAutocomplete: hideAutocomplete,
      autocompleteSelector: autocompleteSelector,
      instantsearchSelector: selector,
      paginationSelector: paginationSelector
    });

    this.instantsearch = (0, _instantsearch2.default)({
      appId: applicationId,
      apiKey: apiKey,
      indexName: this.indexName,
      urlSync: {
        mapping: {
          q: 'query'
        }
      },
      searchParameters: {
        analytics: analytics,
        attributesToSnippet: ['body_safe:40'],
        highlightPreTag: '<span class="ais-highlight">',
        highlightPostTag: '</span>',
        snippetEllipsisText: '...',
        clickAnalytics: clickAnalytics
      },
      searchFunction: function searchFunction(_ref2) {
        var search = _ref2.search;

        var helper = _this.instantsearch.helper;
        var query = helper.state.query;
        var optionalWords = (0, _stopwords2.default)(query, _this.locale);
        var page = helper.getPage();
        helper.setQueryParameter('optionalWords', optionalWords);
        helper.setPage(page);
        search();
      }
    });

    this.instantsearch.client.addAlgoliaAgent('Zendesk Integration (__VERSION__)');
  }

  _createClass(InstantSearch, [{
    key: 'render',
    value: function render(_ref3) {
      var _this2 = this;

      var autocompleteSelector = _ref3.autocomplete.inputSelector,
          baseUrl = _ref3.baseUrl,
          clickAnalytics = _ref3.clickAnalytics,
          color = _ref3.color,
          highlightColor = _ref3.highlightColor,
          _ref3$instantsearch = _ref3.instantsearch,
          enabled = _ref3$instantsearch.enabled,
          hitsPerPage = _ref3$instantsearch.hitsPerPage,
          selector = _ref3$instantsearch.selector,
          paginationSelector = _ref3$instantsearch.paginationSelector,
          reuseAutocomplete = _ref3$instantsearch.reuseAutocomplete,
          hideAutocomplete = _ref3$instantsearch.hideAutocomplete,
          tagsLimit = _ref3$instantsearch.tagsLimit,
          useEditedAt = _ref3$instantsearch.useEditedAt,
          showHitsFullPath = _ref3$instantsearch.showHitsFullPath,
          locale = _ref3.locale,
          poweredBy = _ref3.poweredBy,
          responsive = _ref3.responsive,
          subdomain = _ref3.subdomain,
          templates = _ref3.templates,
          translations = _ref3.translations;

      if (!enabled) return;

      this.locale = locale;

      var searchBoxSelector = void 0;

      (0, _addCSS2.default)(templates.instantsearch.css({ color: color, highlightColor: highlightColor }));

      if (reuseAutocomplete) {
        (0, _addCSS2.default)('#algolia-query { display: none }');
        searchBoxSelector = autocompleteSelector;
      } else {
        this.$autocompleteInputs = document.querySelectorAll(autocompleteSelector);
        if (hideAutocomplete) this._hideAutocomplete();
        searchBoxSelector = '#algolia-query';
      }

      this.$oldPagination = document.querySelector(paginationSelector);
      if (this.$oldPagination !== null) {
        this.$oldPagination.style.display = 'none';
      }

      this.$container = document.querySelector(selector);
      if (this.$container === null) {
        throw new Error('[Algolia] Cannot find a container with the "' + selector + '" selector.');
      }
      this.$container.innerHTML = templates.instantsearch.layout({
        translations: translations
      });

      this._handleResponsiveness({ responsive: responsive, templates: templates });

      this.instantsearch.addWidget({
        getConfiguration: function getConfiguration() {
          return { facets: ['locale.locale'] };
        },
        init: function init(_ref4) {
          var helper = _ref4.helper;

          // Filter by language
          var page = helper.getPage();
          helper.addFacetRefinement('locale.locale', _this2.locale);
          helper.setPage(page);
        }
      });

      if (poweredBy === true) {
        poweredBy = {
          template: templates.instantsearch.poweredBy({
            subdomain: subdomain,
            translations: translations
          })
        };
      }

      this.instantsearch.addWidget(_instantsearch2.default.widgets.searchBox({
        container: searchBoxSelector,
        placeholder: translations.placeholder,
        autofocus: true,
        poweredBy: poweredBy,
        cssClasses: {
          root: reuseAutocomplete ? '' : 'ais-with-style'
        }
      }));

      this.instantsearch.addWidget(_instantsearch2.default.widgets.stats({
        container: '#algolia-stats',
        templates: {
          body: function body(_ref5) {
            var nbHits = _ref5.nbHits,
                processingTimeMS = _ref5.processingTimeMS;
            return translations.stats(nbHits, processingTimeMS);
          }
        },
        transformData: function transformData(data) {
          return _extends({}, data, {
            translations: translations
          });
        }
      }));

      this.instantsearch.addWidget(_instantsearch2.default.widgets.pagination({
        container: '#algolia-pagination',
        cssClasses: {
          root: 'pagination'
        }
      }));

      this.instantsearch.addWidget(_instantsearch2.default.widgets.hierarchicalMenu({
        container: '#algolia-categories',
        attributes: ['category.title', 'section.full_path'],
        separator: ' > ',
        templates: {
          header: translations.categories,
          item: templates.instantsearch.hierarchicalItem
        }
      }));

      this.instantsearch.addWidget(_instantsearch2.default.widgets.refinementList({
        container: '#algolia-labels',
        attributeName: 'label_names',
        operator: 'and',
        templates: {
          header: translations.tags
        },
        limit: tagsLimit
      }));

      this.instantsearch.addWidget(_instantsearch2.default.widgets.hits({
        container: '#algolia-hits',
        hitsPerPage: hitsPerPage,
        templates: {
          empty: templates.instantsearch.noResult,
          item: templates.instantsearch.hit
        },
        transformData: {
          empty: function empty(data) {
            return _extends({}, data, {
              translations: translations
            });
          },
          item: function item(hit) {
            return _extends({}, hit, {
              useEditedAt: useEditedAt,
              showHitsFullPath: showHitsFullPath,
              baseUrl: baseUrl,
              position: hit.__hitIndex + 1,
              queryID: _this2.instantsearch.helper.lastResults._rawResults[0].queryID
            });
          }
        }
      }));

      this.instantsearch.addWidget({
        init: function init() {
          _this2._addClickListener(clickAnalytics);
        }
      });

      var firstRender = true;
      this.instantsearch.on('render', function () {
        _this2._displayTimes();
        if (firstRender) {
          firstRender = false;
          _this2._bindNoResultActions();
        }
      });

      this.instantsearch.start();
      this._temporaryHidingCancel();
    }

    // Protected

  }, {
    key: '_displayTimes',
    value: function _displayTimes() {
      // eslint-disable-next-line import/no-extraneous-dependencies
      var moment = require('moment');
      var timezoneOffset = moment().zone();
      moment().lang(this.locale); // Doesn't work, as we're missing translations
      var times = document.querySelectorAll('time');
      for (var i = 0; i < times.length; ++i) {
        var $time = times[i];
        var datetime = $time.getAttribute('datetime');
        var formattedDatetime = moment(datetime).utc().zone(timezoneOffset);
        var isoTitle = formattedDatetime.format('YYYY-MM-DD HH:mm');

        $time.setAttribute('title', isoTitle);

        // Render time[data-datetime='relative'] as 'time ago'
        if ($time.getAttribute('data-datetime') === 'relative') {
          $time.textContent = formattedDatetime.fromNow();
        } else if ($time.getAttribute('data-datetime') === 'calendar') {
          $time.textContent = formattedDatetime.calendar();
        }
      }
    }
  }, {
    key: '_hideAutocomplete',
    value: function _hideAutocomplete() {
      for (var i = 0, len = this.$autocompleteInputs.length; i < len; ++i) {
        var $input = this.$autocompleteInputs[i];
        var $elt = $input;
        var $parent = $elt.parentNode;
        // Find closest form
        while ($elt !== null && $elt.nodeName.toLowerCase() !== 'form') {
          $elt = $parent;
          $parent = $elt.parentNode;
        }
        // If no form found reset
        if ($elt === null) {
          $elt = $input;
          $parent = $elt.parentNode;
        }
        // Get the closest parent to have more than one child
        while ($elt !== null && $parent.children.length === 1) {
          $elt = $parent;
          $parent = $elt.parentNode;
        }
        $elt.style.display = 'none';
      }
    }
  }, {
    key: '_bindNoResultActions',
    value: function _bindNoResultActions() {
      var _this3 = this;

      this.$container.addEventListener('click', function (e) {
        for (var target = e.target; target && target !== _this3; target = target.parentNode) {
          // eslint-disable-next-line no-continue
          if (target.classList === undefined) continue;
          if (target.classList.contains('ais-change-query')) {
            _this3.instantsearch.helper.setQuery('').search();
          }
        }
      }, false);
      this.$container.addEventListener('click', function (e) {
        for (var target = e.target; target && target !== _this3; target = target.parentNode) {
          // eslint-disable-next-line no-continue
          if (target.classList === undefined) continue;
          if (target.classList.contains('ais-clear-filters')) {
            _this3.instantsearch.helper.clearRefinements().addFacetRefinement('locale.locale', _this3.locale).search();
          }
        }
      }, false);
    }
  }, {
    key: '_handleResponsiveness',
    value: function _handleResponsiveness(_ref6) {
      var templates = _ref6.templates,
          responsive = _ref6.responsive;

      if (!responsive) return;
      var $mainStyle = (0, _addCSS2.default)(templates.instantsearch.responsiveCSS);

      // Responsive filters
      var $responsiveCSSFacets = null;
      document.getElementById('algolia-facets-open').addEventListener('click', function () {
        if ($responsiveCSSFacets === null) {
          $responsiveCSSFacets = (0, _addCSS2.default)(templates.instantsearch.responsiveCSSFacets, $mainStyle);
        }
      });
      document.getElementById('algolia-facets-close').addEventListener('click', function () {
        (0, _removeCSS2.default)($responsiveCSSFacets);
        $responsiveCSSFacets = null;
      });
    }
  }, {
    key: '_temporaryHiding',
    value: function _temporaryHiding(_ref7) {
      var hideAutocomplete = _ref7.hideAutocomplete,
          autocompleteSelector = _ref7.autocompleteSelector,
          instantsearchSelector = _ref7.instantsearchSelector,
          paginationSelector = _ref7.paginationSelector;

      var selector = instantsearchSelector + ', ' + paginationSelector;
      if (hideAutocomplete) selector += ', ' + autocompleteSelector;
      this._temporaryHidingCSS = (0, _addCSS2.default)('\n      ' + selector + ' {\n        display: none !important;\n        visibility: hidden !important;\n      }\n    ');
    }
  }, {
    key: '_temporaryHidingCancel',
    value: function _temporaryHidingCancel() {
      (0, _removeCSS2.default)(this._temporaryHidingCSS);
      delete this._temporaryHidingCSS;
    }

    // attach the event listener only once on container and find article link at click time

  }, {
    key: '_addClickListener',
    value: function _addClickListener(clickAnalytics) {
      var _this4 = this;

      if (!clickAnalytics) return;
      this.$container.addEventListener('click', function (e) {
        var $target = e.target;
        var $link = $target.closest('a.search-result-link');
        if (!$link) return;
        var $article = $link.closest('.search-result');
        if (!$article) {
          console.error("Couldn't find associated article for link", $link);
          return;
        }
        var objectID = $article.getAttribute('data-algolia-objectid');
        var articleID = $article.getAttribute('data-algolia-articleid');
        var position = $article.getAttribute('data-algolia-position');
        var queryID = $article.getAttribute('data-algolia-queryid');
        _this4.trackClick({ objectID: objectID, id: articleID }, position, queryID);
      });
    }
  }]);

  return InstantSearch;
}();

exports.default = function () {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return new (Function.prototype.bind.apply(InstantSearch, [null].concat(args)))();
};