'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.STOPWORDS = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /* Languages stopwords */

exports.default = getStopWords;

var _ar = require('stopwords/dist/ar.json');

var _ar2 = _interopRequireDefault(_ar);

var _bg = require('stopwords/dist/bg.json');

var _bg2 = _interopRequireDefault(_bg);

var _cs = require('stopwords/dist/cs.json');

var _cs2 = _interopRequireDefault(_cs);

var _da = require('stopwords/dist/da.json');

var _da2 = _interopRequireDefault(_da);

var _de = require('stopwords/dist/de.json');

var _de2 = _interopRequireDefault(_de);

var _el = require('stopwords/dist/el.json');

var _el2 = _interopRequireDefault(_el);

var _en = require('stopwords/dist/en.json');

var _en2 = _interopRequireDefault(_en);

var _es = require('stopwords/dist/es.json');

var _es2 = _interopRequireDefault(_es);

var _fi = require('stopwords/dist/fi.json');

var _fi2 = _interopRequireDefault(_fi);

var _fr = require('stopwords/dist/fr.json');

var _fr2 = _interopRequireDefault(_fr);

var _hu = require('stopwords/dist/hu.json');

var _hu2 = _interopRequireDefault(_hu);

var _id = require('stopwords/dist/id.json');

var _id2 = _interopRequireDefault(_id);

var _it = require('stopwords/dist/it.json');

var _it2 = _interopRequireDefault(_it);

var _ja = require('stopwords/dist/ja.json');

var _ja2 = _interopRequireDefault(_ja);

var _ko = require('stopwords/dist/ko.json');

var _ko2 = _interopRequireDefault(_ko);

var _nl = require('stopwords/dist/nl.json');

var _nl2 = _interopRequireDefault(_nl);

var _no = require('stopwords/dist/no.json');

var _no2 = _interopRequireDefault(_no);

var _pl = require('stopwords/dist/pl.json');

var _pl2 = _interopRequireDefault(_pl);

var _pt = require('stopwords/dist/pt.json');

var _pt2 = _interopRequireDefault(_pt);

var _ro = require('stopwords/dist/ro.json');

var _ro2 = _interopRequireDefault(_ro);

var _ru = require('stopwords/dist/ru.json');

var _ru2 = _interopRequireDefault(_ru);

var _sk = require('stopwords/dist/sk.json');

var _sk2 = _interopRequireDefault(_sk);

var _sv = require('stopwords/dist/sv.json');

var _sv2 = _interopRequireDefault(_sv);

var _th = require('stopwords/dist/th.json');

var _th2 = _interopRequireDefault(_th);

var _tr = require('stopwords/dist/tr.json');

var _tr2 = _interopRequireDefault(_tr);

var _zh = require('stopwords/dist/zh.json');

var _zh2 = _interopRequireDefault(_zh);

var _unorm = require('unorm');

var _unorm2 = _interopRequireDefault(_unorm);

var _regexpEscape = require('./regexpEscape');

var _regexpEscape2 = _interopRequireDefault(_regexpEscape);

var _uk = require('./stopwords/uk');

var _uk2 = _interopRequireDefault(_uk);

var _vi = require('./stopwords/vi');

var _vi2 = _interopRequireDefault(_vi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var STOPWORDS = exports.STOPWORDS = {
  ar: _ar2.default,
  'ar-eg': _ar2.default,
  bg: _bg2.default,
  cs: _cs2.default,
  da: _da2.default,
  de: _de2.default,
  'de-at': _de2.default,
  'de-ch': _de2.default,
  el: _el2.default,
  'en-au': _en2.default,
  'en-ca': _en2.default,
  'en-gb': _en2.default,
  'en-ie': _en2.default,
  'en-us': _en2.default,
  es: _es2.default,
  'es-es': _es2.default,
  'es-419': _es2.default,
  fi: _fi2.default,
  fr: _fr2.default,
  'fr-be': _fr2.default,
  'fr-ca': _fr2.default,
  'fr-ch': _fr2.default,
  'fr-fr': _fr2.default,
  hu: _hu2.default,
  id: _id2.default,
  it: _it2.default,
  ja: _ja2.default,
  ko: _ko2.default,
  nl: _nl2.default,
  'nl-be': _nl2.default,
  no: _no2.default,
  pl: _pl2.default,
  pt: _pt2.default,
  'pt-br': _pt2.default,
  ro: _ro2.default,
  ru: _ru2.default,
  sk: _sk2.default,
  sv: _sv2.default,
  th: _th2.default,
  tr: _tr2.default,
  uk: _uk2.default,
  vi: _vi2.default,
  'zh-cn': _zh2.default,
  'zh-tw': _zh2.default
};

var CURRENT_STOPWORDS = null;

function getStopWords(query, lang) {
  if (CURRENT_STOPWORDS === null) {
    CURRENT_STOPWORDS = (STOPWORDS[lang] || []).map(function (word) {
      return _unorm2.default.nfc(word);
    }).map(function (word) {
      return [word, new RegExp('(^|\\s)' + (0, _regexpEscape2.default)(word) + '(\\s|$)', 'i')];
    });
  }
  query = _unorm2.default.nfc(query);
  return CURRENT_STOPWORDS.filter(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        reg = _ref2[1];

    return reg.test(query);
  }).map(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 1),
        word = _ref4[0];

    return word;
  });
}